program cast_nonstrict_demo
use forpy_mod
  implicit none

  type(object) :: obj
  character(len=:), allocatable :: fstr
  integer :: an_int
  integer :: ierror

  ierror = forpy_initialize()
  ierror = cast(obj, 3.14d0)           !creates a Python float

  ierror = cast(an_int, obj)           !FAIL: strict cast float->integer
  call err_print                       !show and clear error
  ierror = cast(fstr, obj)             !FAIL: obj is a number, not a string
  call err_print                       !show and clear error

  ierror = cast_nonstrict(an_int, obj) !OK, truncates float (an_int = 3)
  ierror = cast_nonstrict(fstr, obj)   !OK, result is string "3.14"

  write(*,*) an_int
  write(*,*) fstr

  call obj%destroy
  call forpy_finalize
end program