program tuple_example
  use forpy_mod
  implicit none

  integer :: ierror
  type(tuple) :: tu
  type(object) :: item
  integer :: int_value
  character(len=:), allocatable :: str_value
  integer :: ii
  integer :: tu_len

  ierror = forpy_initialize()

  ! Python: tu = (17, "hello", 23, "world")
  ierror = tuple_create(tu, 4) ! create tuple with 4 elements
  ! Must set all tuple elements before using tuple
  ierror = tu%setitem(0, 17)
  ierror = tu%setitem(1, "hello")
  ierror = tu%setitem(2, 23)
  ierror = tu%setitem(3, "world")

  ierror = tu%len(tu_len)

  do ii = 0, tu_len-1  ! Python indices start at 0
    ierror = tu%getitem(item, ii)

    ! Use is_int, is_str, is_float, is_none ...
    ! to check if an object is of a certain Python type
    if (is_int(item)) then
      ! Use cast to transform 'item' into Fortran type
      ierror = cast(int_value, item)
      write(*,*) int_value
    else if(is_str(item)) then
      ierror = cast(str_value, item)
      write(*,*) str_value
    endif

    call item%destroy
  enddo

  call tu%destroy
  call forpy_finalize

end program
