# Pour compiler:
#      python setup.py build_ext --inplace

import glob
import os
import sys

from Cython.Distutils import build_ext

from distutils.core import setup, Extension
from distutils.sysconfig import get_config_vars

import numpy

compiler = sys.argv.pop(2)

EXTENSIONS = [Extension('benchmark',
                        include_dirs=[numpy.get_include()],
                        library_dirs = ["shared"],
                        libraries=['Fortran'],
                        sources = ['benchmark_binding.pyx']
                        )]
setup (name = "Benchmark",
           version = "1.0",
           ext_modules = EXTENSIONS,
           package = "Benchmark",
           package_dir      = {"Benchmark":"."},
           cmdclass = {'build_ext': build_ext})